/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;
//导入Android平台提供的各种功能模块，用于构建和管理应用程序的活动、对话框、意图等功能
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.DialogInterface.OnDismissListener;
import android.content.Intent;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.PowerManager;
import android.provider.Settings;
import android.view.Window;
import android.view.WindowManager;
//导入自定义的资源文件和数据处理工具类
import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.tool.DataUtils;

import java.io.IOException;


public class AlarmAlertActivity extends Activity implements OnClickListener, OnDismissListener {
    private long mNoteId;
    private String mSnippet;
    private static final int SNIPPET_PREW_MAX_LEN = 60;
    MediaPlayer mPlayer;

    @Override
    //在活动创建时被调用，用于初始化活动
    //调用父类的onCreate方法进行基本初始化
    //移除窗口标题
    //配置窗口在锁定状态下显示
    //根据屏幕状态，添加额外的窗口标志以确保应用在特定场景下的可见性和屏幕行为
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        final Window win = getWindow();
        win.addFlags(WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED);

        if (!isScreenOn()) {
            win.addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_ALLOW_LOCK_WHILE_SCREEN_ON
                    | WindowManager.LayoutParams.FLAG_LAYOUT_INSET_DECOR);
        }

        Intent intent = getIntent();

        try {
            //从intent中提取笔记ID
            mNoteId = Long.valueOf(intent.getData().getPathSegments().get(1));
            //根据ID获取笔记摘要
            mSnippet = DataUtils.getSnippetById(this.getContentResolver(), mNoteId);
            //如果摘要长度超过预览最大长度，截取并添加提示信息
            mSnippet = mSnippet.length() > SNIPPET_PREW_MAX_LEN ? mSnippet.substring(0,
                    SNIPPET_PREW_MAX_LEN) + getResources().getString(R.string.notelist_string_info)
                    : mSnippet;
        } catch (IllegalArgumentException e) {
            //捕获非法参数异常并打印堆栈跟踪
            e.printStackTrace();
            //异常情况下返回
            return;
        }
        //初始化MediaPlayer对象用于播放音频
        mPlayer = new MediaPlayer();
        // 检查数据库中是否存在可见的笔记
        if (DataUtils.visibleInNoteDatabase(getContentResolver(), mNoteId, Notes.TYPE_NOTE)) {
            //如果存在，显示操作对话框并播放提醒声音
            showActionDialog();
            playAlarmSound();
        } else {
            //如果不存在，结束当前活动或进程
            finish();
        }
    }
    //检查屏幕是否处于开启状态
    //通过访问系统服务中的PowerManager来获取屏幕的状态信息
    // 此方法用于判断当前设备的屏幕是否点亮，以便在需要时采取相应操作
    private boolean isScreenOn() {
        //获取PowerManager实例以管理电源相关操作
        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        //使用PowerManager的isScreenOn方法检查屏幕状态并返回
        return pm.isScreenOn();
    }
    //本方法首先获取系统默认的报警铃声URI，然后根据系统设置的静音模式
    //选择合适的音频流类型播放报警声音
    private void playAlarmSound() {
        //获取系统默认的报警铃声URI
        Uri url = RingtoneManager.getActualDefaultRingtoneUri(this, RingtoneManager.TYPE_ALARM);
        //获取系统静音模式下受影响的音频流类型
        int silentModeStreams = Settings.System.getInt(getContentResolver(),
                Settings.System.MODE_RINGER_STREAMS_AFFECTED, 0);
        //判断静音模式是否影响报警音频流
        if ((silentModeStreams & (1 << AudioManager.STREAM_ALARM)) != 0) {
            //如果影响，则使用系统设置的静音模式对应的音频流类型
            mPlayer.setAudioStreamType(silentModeStreams);
        } else {
            //如果不影响，则直接使用报警音频流类型
            mPlayer.setAudioStreamType(AudioManager.STREAM_ALARM);
        }
        try {
            //设置媒体播放器的数据源
            mPlayer.setDataSource(this, url);
            //准备媒体播放器
            mPlayer.prepare();
            //设置循环播放
            mPlayer.setLooping(true);
            //开始播放
            mPlayer.start();
        } catch (IllegalArgumentException e) {
            //当参数无效时，打印异常信息
            // TODO Auto-generated catch block
            //当没有权限访问指定的数据源时，打印异常信息
            e.printStackTrace();
        } catch (SecurityException e) {
            //当媒体播放器处于不适合的操作状态时，打印异常信息
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IllegalStateException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            //当数据源不可访问或发生I/O错误时，打印异常信息
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    //用于创建并显示一个操作对话框该对话框包含一个标题、一条消息内容、一个确定按钮，
    // 并根据屏幕状态决定是否显示一个取消按钮对话框的样式和内容是根据当前应用的主题和提供的
    //  字符串资源来定制的
    private void showActionDialog() {
        //创建AlertDialog实例，用于构建对话框界面
        AlertDialog.Builder dialog = new AlertDialog.Builder(this);
        //设置对话框标题为应用名称
        dialog.setTitle(R.string.app_name);
        //设置对话框的消息内容
        dialog.setMessage(mSnippet);
        //设置确定按钮，点击时将执行当前类中定义的onClick方法
        dialog.setPositiveButton(R.string.notealert_ok, this);
        //根据屏幕状态决定是否设置取消按钮，以适应不同的使用场景
        if (isScreenOn()) {
            dialog.setNegativeButton(R.string.notealert_enter, this);
        }
        // 显示对话框，并设置关闭监听器，当对话框关闭时将执行当前类中定义的onDismiss方法
        dialog.show().setOnDismissListener(this);
    }
    //处理对话框的点击事件
    //  dialog 接口对话框对象，用于识别和操作对话框
    //   which 点击的按钮标识，用于判断用户点击的是哪个按钮
    public void onClick(DialogInterface dialog, int which) {
        //根据点击的按钮标识进行相应的操作
        switch (which) {
            //当用户点击的是负向按钮时
            case DialogInterface.BUTTON_NEGATIVE:
               // 创建一个意图，用于启动NoteEditActivity
                Intent intent = new Intent(this, NoteEditActivity.class);
                //设置意图的动作，表示查看操作
                intent.setAction(Intent.ACTION_VIEW);
                //设置意图的动作，表示查看操作
                intent.putExtra(Intent.EXTRA_UID, mNoteId);
                //使用意图启动活动
                startActivity(intent);
                //对于其他按钮点击情况，不执行任何操作
                break;
            default:
                break;
        }
    }
    // 当对话框被关闭时调用的方法
    // 该方法负责停止报警声音并结束当前活动
    //  dialog 接口对话框对象，表示哪个对话框被关闭
    public void onDismiss(DialogInterface dialog) {
        //停止报警声音
        stopAlarmSound();
        //结束当前活动
        finish();
    }
    //停止报警声音的方法
    //  该方法检查媒体播放器是否不为空，然后停止播放并释放资源
    private void stopAlarmSound() {
        //检查媒体播放器是否不为空
        if (mPlayer != null) {
            //停止媒体播放器的播放
            mPlayer.stop();
            //释放媒体播放器的资源
            mPlayer.release();
            //将媒体播放器设置为null，表示不再使用
            mPlayer = null;
        }
    }
}
